package com.jsevy.jxml;

import org.w3c.dom.DOMException;
import org.w3c.dom.CharacterData;

public abstract class XMLCharacterData extends XMLNode implements CharacterData
{
    
    
    protected XMLCharacterData(String name, String value)
    {
        // just pass on to XMLNode
        super(name, value);
    }
    
    
    
    @Override
    public String getData() throws DOMException
    {
        return this.getNodeValue();
    }
    
    
    
    @Override
    public void setData(String data) throws DOMException
    {
        this.setNodeValue(data);
    }
    
    
    
    @Override
    public int getLength()
    {
        return this.getValueBuffer().length();
    }
    
    
    
    @Override
    public String substringData(int offset, int count) throws DOMException
    {
        return this.getValueBuffer().substring(offset, offset + count);
    }
    
    
    
    @Override
    public void appendData(String arg) throws DOMException
    {
        this.getValueBuffer().append(arg);
    }
    
    
    
    @Override
    public void insertData(int offset, String arg) throws DOMException
    {
        this.getValueBuffer().insert(offset, arg);
    }
    
    
    
    @Override
    public void deleteData(int offset, int count) throws DOMException
    {
        this.getValueBuffer().delete(offset, offset + count);
    }
    
    
    
    @Override
    public void replaceData(int offset, int count, String arg) throws DOMException
    {
        this.getValueBuffer().replace(offset, offset + count, arg);
    }
    
}
